unit USoma;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, System.Generics.Collections,
  Vcl.StdCtrls;

const
  DLL_LOCATION = 'ted.dll';
  //DLL_LOCATION = 'C:\Users\Carlos\Documents\Projetos\Colleter\DLL\ted.dll';

  TEDStartMessages: array [0..1] of string = (
    'Erro na abertura da porta!',
    'Porta aberta com sucesso!'
  );

type
  TForm1 = class(TForm)
    Label1: TLabel;
    GroupBox4: TGroupBox;
    Label4: TLabel;
    Porta: TEdit;
    Button1: TButton;
    lblMensagem: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure RunProgram(ip, data: String);
  public
    { Public declarations }
  end;

  TTEDConnectEvent = procedure(ip: string);
  TTEDReceiveEvent = procedure(ip, data: string; hdr: Integer);

  function TEDStart(port: integer): integer; external DLL_LOCATION;
  function TEDBeep(ip: string; times: integer): integer; external DLL_LOCATION;
  function TEDDisplaySend(ip, data: string): integer; external DLL_LOCATION;
  function TEDCom1Send(ip, data: string): integer; external DLL_LOCATION;
  function TEDCom2Send(ip, data: string): integer; external DLL_LOCATION;
  function TEDDisplayClear(ip: string): integer; external DLL_LOCATION;
  function TEDListClear(ip: string): integer; external DLL_LOCATION;
  function TEDListAdd(ip: string; data: string): integer; external DLL_LOCATION;
  function TEDHeaderOn(ip: string): integer; external DLL_LOCATION;
  function TEDHeaderOff(ip: string): integer; external DLL_LOCATION;
  function TEDDigitalOn(ip: string): integer; external DLL_LOCATION;
  function TEDDigitalOff(ip: string): integer; external DLL_LOCATION;
  function TEDDigitalRead(ip: string): integer; external DLL_LOCATION;

  procedure onTEDConnect(hnd: TTEDConnectEvent); external DLL_LOCATION;
  procedure onTEDReceive(hnd: TTEDReceiveEvent); external DLL_LOCATION;

var
  Form1: TForm1;
  TEDs: TDictionary<String, Integer>;    // IP + ID DO COMANDO ATUAL PARA O TED
  Buffers: TDictionary<String, Integer>; // IP + DADO DO COMANDO ATUAL PARA O TED

implementation

{$R *.dfm}

{ TForm1 }

procedure conectado(ip: String);
var
  id: Integer;
begin
  if (TEDs.TryGetValue(ip, id) = True) then Exit;
  TEDs.AddOrSetValue(ip, 0);
  Form1.RunProgram(ip, '');
end;

procedure recebido(ip, data: String; header: Integer);
begin
  Form1.RunProgram(ip, data);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  ret: integer;
begin
  onTEDConnect(conectado);
  onTEDReceive(recebido);
  ret := TEDStart(StrToIntDef(Porta.Text, 8));
  lblMensagem.Caption := TEDStartMessages[ret];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TEDs := TDictionary<String, Integer>.Create;
  Buffers := TDictionary<String, Integer>.Create;
end;

procedure TForm1.RunProgram(ip, data: String);
var
  id, a, b: integer;
begin

  if (TEDs.TryGetValue(ip, id) = false) then Exit;

  if (id = 0) then
  begin
    TEDDisplayClear(ip);
    TEDBeep(ip, 1);
    TEDDisplaySend(ip, 'A:');
  end;

  if (id = 1) then
  begin
    Buffers.AddOrSetValue(ip, StrToIntDef(data, 0));
    TEDBeep(ip, 1);
    TEDDisplaySend(ip, 'B:');
  end;

  if (id = 2) then
  begin
    Buffers.TryGetValue(ip, a);
    b := StrToIntDef(data, 0);
    TEDBeep(ip, 1);
    TEDDisplaySend(ip, 'SOMA:' + IntToStr(a+b));
    TEDDisplaySend(ip, 'A:');
    id := 0;
  end;

  TEDs.AddOrSetValue(ip, id + 1);

end;

end.
